/* SPDX-License-Identifier: GPL-3.0-or-later */
/* Copyright (C) 2021 KikooDX */
#pragma once

#include <gint/display.h>

enum TransitionMode {
	TransitionNone,
	TransitionHOut,
	TransitionHIn,
	TransitionVIn,
	TransitionVOut
};

struct Transition {
	float step;
	float speed;
	color_t color;
	enum TransitionMode mode;
};

struct Transition transition_init(float speed, color_t color,
                                  enum TransitionMode mode);
enum TransitionMode transition_update(struct Transition *restrict transition);
void transition_draw(struct Transition transition);
void hfade_in(float step, color_t color);
void hfade_out(float step, color_t color);
void vfade_in(float step, color_t color);
void vfade_out(float step, color_t color);
