/* SPDX-License-Identifier: GPL-3.0-or-later */
/* Copyright (C) 2021 KikooDX */

#include "conf.h"
#include "player.h"

static int collide_water(int x, int y);

int
player_collide_water(struct Player player)
{
	const int lx = player.x;
	const int rx = player.x + PLAYER_WIDTH - 1;
	const int ty = player.y;
	const int dy = player.y + PLAYER_HEIGHT - 1;

	return collide_water(lx, ty) || collide_water(lx, dy) ||
	       collide_water(rx, ty) || collide_water(rx, dy);
}

static int
collide_water(int x, int y)
{
	return level_is_water((int)(x / TILE_WIDTH), (int)(y / TILE_WIDTH));
}
